//
//  Controller.m
//  PDF2Text
//
//  Created by Debenu Pty Ltd on 9/15/12.
//  Copyright (c) 2012 Debenu Pty Ltd. All rights reserved.
//

#import "Controller.h"
#import "DebenuPDFLibraryDylibClass1015.h"

#define DQPLErrorDomain @"DQPLErrorDomain"

@implementation Controller

- (BOOL)createTextFromPDF:(NSString*)pdfFilePath toPath:(NSString*)toFilePath error:(NSError**)error
{
    // extract text from pdf
    NSBundle* mainBundle = [NSBundle mainBundle];
    NSString* dylibPath = [[mainBundle executablePath] stringByDeletingLastPathComponent];
    
    dylibPath = [dylibPath stringByAppendingPathComponent:@"libDebenuPDFLibraryDylib1015.dylib"];
    DebenuPDFLibraryDylibClass1015* DQPL = [[[DebenuPDFLibraryDylibClass1015 alloc] initWithDylibFileName:dylibPath]autorelease];
    
    
    NSString* key = @"*** insert your license key here ***";
    
    if( [DQPL UnlockKey:key] != 1 ) {
        
        if( error != NULL ) {
            *error = [NSError errorWithDomain:DQPLErrorDomain
                                         code:0
                                     userInfo:[NSDictionary dictionaryWithObject:[NSString stringWithFormat:@"Failed to unlock DQPL with %@", key] forKey:NSLocalizedDescriptionKey]];
            
        }
        
        return NO;
    }
    
    if( [DQPL LoadFromFile:pdfFilePath :nil] != 1 ) {
        
        if( error != NULL ) {
            *error = [NSError errorWithDomain:DQPLErrorDomain
                                         code:0
                                     userInfo:[NSDictionary dictionaryWithObject:[NSString stringWithFormat:@"Failed to open %@", pdfFilePath] forKey:NSLocalizedDescriptionKey]];
            
        }
        
        return NO;
    }

    int pageCount = [DQPL PageCount];
    
    NSMutableString* pdfText = [NSMutableString string];
    
    for( int nPage = 0; nPage < pageCount; ++nPage ) {
        [pdfText appendString:[DQPL ExtractFilePageText:pdfFilePath :@"" :nPage+1 :0]];
    }

    [pdfText writeToFile:toFilePath
              atomically:NO
                encoding:NSUTF8StringEncoding
                   error:nil];
    
    return YES;
}

@end
