//
//  AppDelegate.m
//  PDFMerge
//
//  Created by Debenu Pty Ltd on 9/18/12.
//  Copyright (c) 2012 Debenu Pty Ltd. All rights reserved.
//

#import "AppDelegate.h"
#import "Controller.h"

@implementation AppDelegate
@synthesize window;

- (void)dealloc
{
    [super dealloc];
}

- (void)applicationDidFinishLaunching:(NSNotification *)aNotification
{
    
}

- (IBAction)choose:(id)sender
{
    NSOpenPanel* openPanel = [NSOpenPanel openPanel];
    [openPanel setAllowsMultipleSelection:NO];
    [openPanel setAllowedFileTypes:[NSArray arrayWithObject:@"pdf"]];
    [openPanel setDirectoryURL:[NSURL fileURLWithPath:NSHomeDirectory()]];
    
    [NSApp beginSheet:openPanel
       modalForWindow:self.window
        modalDelegate:nil
       didEndSelector:nil
          contextInfo:NULL];
    
    NSInteger ret = [NSApp runModalForWindow:openPanel];
    
    [NSApp endSheet:openPanel];
    [openPanel orderOut:self];
    
    if( ret != NSOKButton )
        return;
    
    NSArray* URLs = [openPanel URLs];
    [_pathField setStringValue:[[URLs objectAtIndex:0] path]];
}

- (IBAction)split:(id)sender
{
    [self.window makeFirstResponder:nil];
    
    NSFileManager* fileManager = [NSFileManager defaultManager];
    
    NSString* sourceFilePath = _pathField.stringValue;
    
    BOOL existFile = [fileManager fileExistsAtPath:sourceFilePath];
    
    if( !existFile ) {
        
        NSAlert* alert = [NSAlert alertWithMessageText:@"Please choose correct file."
                                         defaultButton:@"OK"
                                       alternateButton:nil
                                           otherButton:nil
                             informativeTextWithFormat:@""];
        
        [alert runModal];
        return;
    }
    
    NSOpenPanel* openPanel = [NSOpenPanel openPanel];
    [openPanel setCanChooseDirectories:YES];
    [openPanel setCanChooseFiles:NO];
    [openPanel setAllowsMultipleSelection:NO];
    [openPanel setDirectoryURL:[NSURL fileURLWithPath:[sourceFilePath stringByDeletingLastPathComponent]]];
    [openPanel setMessage:@"Please select folder where file for splited pages will be created"];
    
    [NSApp beginSheet:openPanel
       modalForWindow:self.window
        modalDelegate:nil
       didEndSelector:nil
          contextInfo:NULL];
    
    NSInteger ret = [NSApp runModalForWindow:openPanel];
    
    [NSApp endSheet:openPanel];
    [openPanel orderOut:self];
    
    if( ret != NSFileHandlingPanelOKButton )
        return;
    
    NSString* toDirPath = [[[openPanel URLs] objectAtIndex:0] path];
    
    NSError* error = nil;

    Controller* controller = [[[Controller alloc] init] autorelease];
    if( ![controller splitFile:sourceFilePath to:toDirPath error:&error] ) {

        NSAlert* alert = [NSAlert alertWithMessageText:@"Error!"
                                         defaultButton:@"OK"
                                       alternateButton:nil
                                           otherButton:nil
                             informativeTextWithFormat:@"%@", [error localizedDescription]];

        [alert runModal];
        return;
    }

    [[NSWorkspace sharedWorkspace] openURL:[NSURL fileURLWithPath:toDirPath]];
}

@end
